# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need a recent version of Test::More
%global quite_old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION) < 0.98 ? 1 : 0);' 2>/dev/null || echo 0)

Summary:	Web validation in a Perl object
Name:		perl-HTML-Tidy
Version:	1.56
Release:	9.0.cf.%{__distinit}%{__distvers}
License:	Artistic 2.0
Group:		Applications/Text
Url:		http://search.cpan.org/dist/HTML-Tidy/
Source0:	http://search.cpan.org/CPAN/authors/id/P/PE/PETDANCE/HTML-Tidy-%{version}.tar.gz
Source1:	T-M-0.98.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	libtidyp-devel
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Config)
BuildRequires:	perl(ExtUtils::Liblist)
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(overload)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Script Runtime
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(LWP::Simple)
# Test Suite
BuildRequires:	perl(Encode)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(LWP::Simple)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
HTML::Tidy is an HTML checker in a handy dandy object. It's meant as
a replacement for HTML::Lint.

%prep
%setup -q -n HTML-Tidy-%{version}

# Use of subtests requires Test::More ≥ 0.96, though upstream seems to think we need 0.98; use a bundled version if we don't have it
%if %{quite_old_test_more}
tar xfz %{SOURCE1}
find inc -type f >> MANIFEST
%endif

%build
# Use our local Test::More if necessary
[ -d inc/ ] && export PERL5LIB=$(pwd)/inc

perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
# Use our local Test::More if necessary
[ -d inc/ ] && export PERL5LIB=$(pwd)/inc

make test

%clean
rm -rf %{buildroot}

%files
%doc Changes README.markdown
%{_bindir}/webtidy
%{perl_vendorarch}/HTML/
%{perl_vendorarch}/auto/HTML/
%{_mandir}/man3/HTML::Tidy.3*
%{_mandir}/man3/HTML::Tidy::Message.3*

%changelog
* Sun Feb 12 2017 Paul Howarth <paul@city-fan.org> - 1.56-9.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Aug 26 2016 Paul Howarth <paul@city-fan.org> - 1.56-8.0.cf
- BR: perl-generators where available
- Simplify find commands using -empty and -delete

* Wed Feb 10 2016 Paul Howarth <paul@city-fan.org> - 1.56-7.0.cf
- Classify buildreqs by usage
- Explicitly BR: perl-devel, needed for EXTERN.h

* Sat Jun 20 2015 Paul Howarth <paul@city-fan.org> - 1.56-6.0.cf
- Perl 5.22 rebuild

* Sun Aug 31 2014 Paul Howarth <paul@city-fan.org> - 1.56-4.0.cf
- Drop %%defattr, redundant since rpm 4.4

* Mon Sep 23 2013 Paul Howarth <paul@city-fan.org> - 1.56-1.0.cf
- Update to 1.56
  - webtidy's version statement now shows the version number of the underlying
    tidyp library
  - Fixed an undef warning in parse()
  - UTF8 was never encoded correctly
  - The ->parse() method would sometimes return false even though everything
    worked fine
- Everything is now licensed Artistic 2.0
- Bundle Test::More 0.98 to support building with distributions that don't have
  it
- Drop unicode patch, no longer needed

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> - 1.54-10.0.cf
- Perl 5.18 rebuild

* Fri Jun 21 2013 Paul Howarth <paul@city-fan.org> - 1.54-9.0.cf
- Fix license tag (HTML::Tidy::Message uses the perl license)

* Sun Jul 15 2012 Paul Howarth <paul@city-fan.org> - 1.54-6.0.cf
- Drop explicit perl(XSLoader) dependency, not actually needed

* Thu Jun 28 2012 Paul Howarth <paul@city-fan.org> - 1.54-5.0.cf
- BR: perl(Exporter) and perl(ExtUtils::Liblist)
- R: perl(XSLoader)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Drop rpath-avoidance hack
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Thu Feb 16 2012 Paul Howarth <paul@city-fan.org> - 1.54-4.0.cf
- One buildreq per line
- Add buildreqs for Perl core modules that might be dual-lived

* Thu Jul  7 2011 Paul Howarth <paul@city-fan.org> - 1.54-3
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Oct  1 2010 Paul Howarth <paul@city-fan.org> - 1.54-2
- Rebuild for gcc bug (#634757)

* Fri Sep 17 2010 Paul Howarth <paul@city-fan.org> - 1.54-1
- Update to 1.54
  - Fixed incorrect calls to croak()
  - Updating all docs referring to libtidyp and Alien::Libtidyp
- License changed to Artistic 2.0

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 1.52-2
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> - 1.52-1
- Update to 1.52 (merge patches from this package)
- Drop upstreamed patches

* Mon May 10 2010 Paul Howarth <paul@city-fan.org> - 1.50-3
- Rebuild for libtidyp-1.02
- Fix dist tag to work with RHEL-6 Beta

* Mon Apr 26 2010 Paul Howarth <paul@city-fan.org> - 1.50-2
- Rebuild for libtidyp-1.00
- Patch for changed generator string in tidyp 1.00
- Remove bogus rpaths for old distributions

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 1.50-1
- Update to 1.50
- Drop upstreamed patches
- Drop perl-libwww-perl dep and replace it with more explicit perl(LWP::Simple)
- Replace libtidy-devel buildreq with libtidyp-devel
- Add patch to look for libtidyp instead of libtidy
- Add patch to work around unicode issues in perl < 5.8.5 so we can build for
  all supported releases (unicode test is skipped with perl 5.8.0)

* Tue Dec  8 2009 Paul Howarth <paul@city-fan.org> - 1.08-7
- Rebuild against libtidy 2009-12-03 snapshot
- Dist tag for Rawhide no longer needs special-casing

* Thu Sep 10 2009 Paul Howarth <paul@city-fan.org> - 1.08-6
- Use %%{?perl_default_filter}
- Add patch to suppress info output we don't want (CPAN RT #32944)

* Sun Mar  1 2009 Paul Howarth <paul@city-fan.org> - 1.08-5
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Tue Mar 11 2008 Paul Howarth <paul@city-fan.org> - 1.08-4
- Rebuild for perl 5.10.0 on Fedora 9

* Wed Jan 23 2008 Paul Howarth <paul@city-fan.org> - 1.08-3
- Include patch from CPAN RT#29593 so that current libtidy works
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Buildrequire perl >= 5.8.5 (older perls fail test suite with UTF problems)

* Thu Jun 28 2007 Paul Howarth <paul@city-fan.org> - 1.08-2
- Impose upper limit on libtidy-devel version to work around CPAN RT#26875

* Tue Jun  5 2007 Paul Howarth <paul@city-fan.org> - 1.08-1
- Update to 1.08
- Fix dist tag for Fedora 7 onwards
- Fix argument order for find with -depth
- BuildRequire perl(ExtUtils::MakeMaker)
- Patch for CPAN RT#14668 removed, now included upstream

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 1.06-3
- Fix distribution tags for development releases
- Define %%{__id_u} in a more portable way

* Wed Mar 22 2006 Paul Howarth <paul@city-fan.org> - 1.06-2
- Simplify distribution-detection
- Apply patch to fix CPAN RT#14668
- Don't use macros in build-time command paths, hardcode them instead
- Remove buildroot unconditionally in %%clean and %%install
- Remove %%__perl_package macro, used only twice
- Remove %%__perl_version macro, used only once
- Use search.cpan.org URLs
- Require a recent libtidy-devel to ensure patched test suite passes

* Thu Aug 25 2005 Paul Howarth <paul@city-fan.org> - 1.06-1
- Update to 1.06
- Change BR from libtidy-devel to tidy-devel
- Add BRs Test::Pod and Test::Pod::Coverage for better test cover

* Sun Jun  5 2005 Paul Howarth <paul@city-fan.org> - 1.04-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
- Tidy up spec file

* Thu May 13 2004 Paul Howarth <paul@city-fan.org> - 1.02-1
- Initial build
